<?php
# Ce fichier ne sera execute qu'une fois
if (defined("_INC_CACHE")) return;
define("_INC_CACHE", "1");

include('inc-dir.php3');

# Vrif de premption d'une compil de squelette par rapport  son source
# et les fonctions utilisateurs agissant sur le compilateur.
# Ses fonction systmes sont supposes ne changer qu' l'installation; 
# sinon vider explicitement par l'interface prive

function squelette_obsolete($naissance, $vetuste)
{
  return (($GLOBALS['recalcul_squelettes'] == 'oui')
	  OR ((filemtime($vetuste) > $naissance)
	      OR ((file_exists("ecrire/mes_options.php3")
		   AND (filemtime("ecrire/mes_options.php3") > $naissance)))
	      OR ((file_exists("mes_fonctions.php3")
		  AND (filemtime("mes_fonctions.php3") > $naissance)))));
}

# Retourne le nom de la fonction principale d'un squelette compil.
# En lance la compilation s'il ne l'tait pas.

function ramener_squelette($squelette)
{  
  $c = md5($squelette);
  $nom = 'squelette_' . $c;

  if (function_exists($nom))
    {
      spip_log("Squelette $squelette:\t($c) dj en mmoire (INCLURE rpt");
      return $nom;
    }
# spip_log("demande verrou $squelette"); 
  if (!$lock = fopen($squelette . '.html', 'rb'))
      $r = '';
  else
    {
#      spip_log("obtient verrou $squelette"); 
# empecher un meme calcul par 2 processus diffrents en se rservant le source
      while (!flock($lock, LOCK_EX));
# remplacer la ligne ci-dessus par les 3 suivantes pour dmonstration:
#  while (!flock($lock, LOCK_EX + LOCK_NB))
# {sleep(1);spip_log("Lock: $nom " . getmypid());}
#  sleep(3);
      $phpfile = subdir_skel() . $c . '.php';
      if (file_exists($phpfile))
	{
	  if (!squelette_obsolete(filemtime($phpfile), $squelette . '.html'))
	    {
	      include($phpfile);
	      if (function_exists($nom))
		{
		  spip_log("Squelette $squelette:\t($c) charg");
		  flock($lock, LOCK_UN);
		  return $nom;
		}
	}
	  # Cache obsolete ou erron.
	  @unlink($phpfile);
	}
      include_local("inc-calcul-squel.php3");
      $timer_a = explode(" ", microtime());
# si vous n'etes pas sous Windows, vous amliorerez les perfs en 
# dcommentant les 2 lignes suivantes (quant  Windows, il fait: $r =""; !)
      $r = # function_exists('file_get_contents') ?
	# file_get_contents($spipfile) : 
	fread($lock, filesize($squelette . '.html'));
    }
# spip_log("calcul de $f par $r");
  if (!$r)
    {
      if ($lock) flock($lock, LOCK_UN);
      include_ecrire ("inc_presentation.php3");
      install_debut_html("Erreur sur le site");
      echo "<h1>squelette <tt>$squelette"  . ".html</tt> illisible...</h1>";
      install_fin_html();
      exit;
    }

  $r = calculer_squelette($r, $nom);
  $timer_b = explode(" ", microtime());
  $timer = ceil(1000*($timer_b[0] + $timer_b[1]-$timer_a[0]-$timer_a[1]));
  $f=fopen($phpfile, "wb"); 
  fwrite($f,"<?php # $squelette pid: " .  getmypid() ."\n");
  fwrite($f,$r);
  fwrite($f,'?>');
  fclose($f);
  flock($lock, LOCK_UN);
  spip_log("Squelette $squelette: ($c) " . strlen($r) . " octets, $timer ms");
  eval($r); # + rapide qu'un include puisqu'on l'a
  return $nom;
}

# vrif de la date de validit d'un cache par rapport 
#  la dure de vie et au temps dont on dispose
# retourne False ou un tableau de 3 lments:
# - texte
# - date de naissance
# - prsence de php  rexecuter

function page_perenne($lock, $file, $fraicheur)
{
  $naissance = filemtime($file);
  $t = time() - $naissance;
  if ((timeout(false,false)) && ($t > $fraicheur)) return false; 
# si vous n'etes pas sous Windows, vous amliorerez les perfs en 
# dcommentant les 2 lignes suivantes (quant  Windows, il fait: $r =""; !)
  $r = # function_exists('file_get_contents') ?
       # file_get_contents($file) : 
	fread($lock, filesize($file));
# la ligne 1 contient un commentaire comportant successivement
# - la longvit du include le plus bref
# - le  type (html ou php)
# - l'URL d'origine (pour info seulement)
  $ok = ereg('^<!-- ([0-9]+)[^0-9a-z]([a-z]+)[^a-z]', $r, $m);
  if (!$ok || ($t > $m[1])) return false;
  return array('texte' => $r,
	       'naissance' => $naissance,
	       'process_ins' => $m[2]);
}

# Retourne une page, dcrite par le tableau de 2 ou 3 lments:
# 'texte' => la page
# 'process_ins' => 'html' ou 'php' si prsence d'un '<?php'
# 'naissance' => heure du calcul si dj calcul (absent si nouveau)

# Si elle n'est pas dans le cache ou que celui-ci est inemployable,
# calcul de la page en appliquant la fonction $calcul sur $contexte
# (tableau de valeurs, hack standard pour langage comme PHP qui
# permettent toutes les horreurs mais pas les belles et utiles fermetures)
# et ecriture dans le cache sous le rpetoire $fraicheur.
# Celle-ci est pase par rfrence, car le dit calcul peut la changer
# $calcul est soit cherche_page_incluse soit cherche_page_incluante
# qui appelle toute deux cherche_page, qui construit le tableau a 2 lments

# Les accs concurrents sont grs par un verrou gnral, 
# remplac rapidement par un verrou spcifique

function ramener_cache($cle, $calcul, $contexte, &$fraicheur)
{
  # pas de mise en cache si:
  # - recherche (trop couteux de mmoriser une recherche prcise)
  # - valeurs hors URL (i.e. POST) sauf Forum qui les traite  part
  
  if ($GLOBALS['var_recherche']||
      ($HTTP_POST_VARS && !$GLOBALS['ajout_forum']))
      {
	include('inc-calcul.php3');
	return $calcul('', $contexte);
      }
# Bloquer/se faire bloquer par TOUS les crateurs de cache
# Ce fichier sert de verrou (on est sur qu'il existe!).
  if (!$lock = fopen('inc-cache.php3', 'rb'))
    return(array('texte' => 'Cache en panne'));
  while (!flock($lock, LOCK_EX));
  $file = file_cache($cle, $fraicheur);
  if (!file_exists($file))
    {
      fclose(fopen($file,'w'));
      $obsolete = false;
      $usefile = false;
    }
  else
    {
      $obsolete = true;
      $usefile = ($GLOBALS['recalcul'] != 'oui');
    }
# Acqurir le verrou spcifique et librer le prcdent
# pour permettre d'autres calculs (notamment d'ventuels include).
# Ouvrir par r+ verrouill pour forcer un 2e processus de mme intention
#  attendre le rsulat du premier et s'en servir. 
# Pour voir, dcommenter le sleep ci-dessous,
# lancer 2 demandes d'une page (surtout  inclusion) et regarder spip_log
#  sleep(3);
#  spip_log("demande de verrou pour $cle"); 
  if (!$lock2 = fopen($file, 'r+b'))
    {
      flock($lock, LOCK_UN);
      return(array('texte' => 'Cache en panne'));
    }
  if (!flock($lock2, LOCK_EX + LOCK_NB))
    {
# un autre processus s'occupe du bb; 
# on se bloque dessus aprs libration du verrou gnral
      flock($lock, LOCK_UN);
      $usefile = true;
      while(!flock($lock2, LOCK_EX));
    }
  else
    flock($lock, LOCK_UN);
#  spip_log("obtient verrou $cle et libre le gnral"); 
  if ($usefile && ($r = page_perenne($lock2, $file, $fraicheur)))
    {
#      spip_log("libre verrou $cle (page perenne)"); 
      flock($lock2, LOCK_UN);
      return $r;
    }
  include('inc-calcul.php3');
  if (!function_exists($calcul))
      {
	flock($lock2, LOCK_UN);
	return(array('texte' => 'Compilateur absent'));
      }
  $page = $calcul($file, $contexte);
  $texte = $page['texte'];
  $n = ($fraicheur ? strlen($texte) : 0);
  if (!$n)
    {
      flock($lock2, LOCK_UN);
      @unlink($file);
    }
  else
    {
      spip_log("Ecriture ($cle): $n octets (validit: $fraicheur sec.)");
      fwrite($lock2, "<!-- $fraicheur " . 
	     $page['process_ins'] .
	     "\t$cle  " .  
	     getmypid() ." -->\n");
      fwrite($lock2,$texte);
      flock($lock2, LOCK_UN);
      fclose($lock2);
      if (file_exists('ecrire/invalideur.php3'))
	{
	  include_ecrire('invalideur.php3');
	  maj_invalideurs($file, $obsolete, $page['invalideurs']);
	  if ($f = $contexte['cache_incluant'])
	    insere_invalideur(array($file => true), 'inclure', $f);
	}
    }
  return $page;
}

# retourne la date de naissance ou 0 si inexistant

function cv_du_cache($cle, $fraicheur)
{
  $file = file_cache($cle, $fraicheur);
  return (file_exists($file) ? filemtime($file) : 0);
}

# dtruit tous les squelettes

function retire_caches_squelette()
{
  $i= 0 ;
  $dir = subdir_skel();
  if ($handle = @opendir($dir))
    {
      while (($fichier = readdir($handle)) != '') {
	if ($fichier[0] != '.') { @unlink("$dir$fichier"); $i++ ;}
      }
    }
  spip_log("Destruction des $i squelette(s)");
}

# dtruit toutes les pages caches et leurs invalideurs
function retire_caches_pages()
{
  $j = 0;
  foreach (alldir_cache() as $dir)
    { 
      if ($handle = opendir($dir))
	{
	  while (($subdir = readdir($handle)) != '') {
	    if (($subdir[0] != '.') && ($handle2 = opendir("$dir$subdir")))
	      {
		while (($fichier = readdir($handle2)) != '') {
		  if ($fichier[0] != '.')
		    { @unlink("$dir$subdir/$fichier"); $j++;}
		}
		@rmdir("$dir$subdir");
	      }
	  }
	}
    }
  spip_log("Destruction des $j cache(s)");
  if (file_exists('ecrire/invalideur.php3'))
    {
      include_ecrire('invalideur.php3');
      supprime_invalideurs();
    }
}

# elimine les caches obsoletes figurant dans le mme rep que la page indique

function retire_vieux_caches($cle, $delais)
{
  $dir = dir_of_file_cache($cle, $delais);
  $tous = trouve_caches('retire_cond_cache', $delais, $dir);
  spip_log("nettoyage de $dir (" . count($tous) . " obsolte(s)");
  if ($tous)
    {
      if (!file_exists('ecrire/invalideur.php3'))
	retire_caches($tous);
      else
	{
	  include_ecrire('invalideur.php3');
	  applique_invalideur($tous);
	}
    }
}

# trouve dans un rpertoire les caches
# vrifiant un prdicat binaire (donn avec son premier argument)

function trouve_caches($cond, $arg, $rep)
{
  if ($handle = opendir($dir))
     {
       while (($fichier = readdir($handle)) != '') {
	 $path = "$dir/$fichier";
	 if ($cond($arg, $path)) $tous[] = $path;
       }
     }
   return $tous;
}

# Teste l'obsolescence d'un cache. 
# Celle de son include le + bref (indique ligne 1) serait + juste
# mais lors d'un balayage de rpertoire, 
# ouvrir chaque fichier serait couteux, et de gain faible

function retire_cond_cache($arg,$path)
{
    return (filemtime($path) <  $arg);
}

# dtruit les caches donns en arguments

function retire_caches($caches)
{
  if ($caches) 
    {foreach ($caches as $path)
	{ @unlink($flag_ecrire ? '../' . $path : $path);}}
}
?>
