<?php

// index_pile retourne la position dans la pile du champ SQL $nom_champ 
// en prenant la boucle la plus proche du sommet de pile (indiqu par $idb).
// Si on ne trouve rien, on considre que a doit provenir du contexte 
// (par l'URL ou l'include) qui a t recopi dans Pile[0]
// (un essai d'affinage a dbouch sur un bug vicieux)
// Si on trouve le champ SQL, on le mmorise dans la structure $boucles
// afin de limiter la requete au serveur SQL aux seuls champs ncessaires.

include_ecrire('inc_serialbase.php3');

function index_pile($idb, $nom_champ, &$boucles)
{
  include_ecrire('inc_globalbase.php3');
  global $exceptions_des_tables, $table_des_tables;

  $i = 0;
  if ($c=strpos($nom_champ, ':'))
     {
       $idbs = substr($nom_champ, 0, $c);
       $nom_champ = substr($nom_champ, $c+1);
       while (($idb != $idbs) && $idb)
	 {$i++; $idb = $boucles[$idb]->id_parent;
#       spip_log("Cherche en amont: $nom_champ '$idbs' '$idb' '$c'");
	 }
     }

  $c = strtolower($nom_champ);
  while ($idb) {
#       spip_log("Cherche: $nom_champ '$idb' '$c'");
    $r = $boucles[$idb]->type_requete;
    // $t est le nom de la table SQL
    $t = $table_des_tables[$r];
    if (!$t) $t = $r; // pour les tables non Spip
    // $a est la valeur de cette table en PHP (cf include globalbase)
    $a = $GLOBALS['spip_' .$t];
#    spip_log("	Dans $r ($t $a): " . $idb);    
    // $e est le type SQL de l'entre (on s'en sert comme boolen uniquement)
    $e = $a[$c];
      if ($e)
      // entit SPIP homonyme au champ SQL
      { $e = $c; }
    else
      {
      // entit SPIP alias d'un champ SQL
	$e = $exceptions_des_tables[$r][$c];
	if (is_array($e))
      // entit SPIP dans une table SQL annexe qu'il faut prciser
	  { $t = $e[0]; $e = $e[1]; } }
    if ($e)
      {
	$boucles[$idb]->select[] = $t . "." . $e;
	return ('$PileRow[$SP' .
		($i ? "-$i" : "") . '][' .
		$e . 
		"]");
	    }
    $idb = $boucles[$idb]->id_parent;
    $i++;
  }
#  spip_log("Pas vu $nom_champ dans les " . count($boucles) . " boucles");
  // esprons qu'il y sera
  return('$PileRow[0]['.$nom_champ.']');
}

// calculer_champ genere le code PHP correspondant a un champ SPIP.
// Retourne un tableau dont le premier lment est une EXPRESSION php 
// et le deuxime une suite d'INSTRUCTIONS  excuter AVANT de calculer
// l'expression (typiquement: un include ou une affectation d'auxiliaires)
// Essayer de renvoyer une suite vide, a diminue les allocations

function calculer_champ($fonctions, $nom_champ, $id_boucle, &$boucles, $id_mere)
{
  global  $exceptions_des_champs;

    // on regarde d'abord si c'est un champs SQL homonyme,
    // sauf pour les faux homonymes

  $code = ($exceptions_des_champs[$nom_champ] ?
	   "" : 
	   index_pile($id_boucle, $nom_champ, &$boucles));

  if ((!$code) || ($code == '$PileRow[0]['.$nom_champ.']'))
    {
      // si index_pile a ramen le choix par dfaut, a doit plutot tre
      // un champ SPIP non SQL
      $f = strpos($nom_champ,'_');
      $f = 'calculer_champ_' . ($f ? substr($nom_champ,0,$f) : $nom_champ);
      if (!function_exists($f)) $f = 'calculer_champ_divers';
      return $f($fonctions, $nom_champ, $id_boucle, &$boucles, $id_mere);
	}
  else 
  return applique_filtres($fonctions, $code, $id_boucle, $boucles, $id_mere);
}

function calculer_champ_divers($fonctions, $nom_champ, $id_boucle, &$boucles, $id_mere)
{
  global  $flag_pcre;

  switch($nom_champ) {

	// Liste des auteurs d'un article
	
	case 'LESAUTEURS':
	  $code =	'query_auteurs(' .
		index_pile($id_boucle,  "id_article", &$boucles) . ')';
		break;

	//
	// Introduction (d'un article, d'une breve ou d'un message de forum)
	//

	case 'INTRODUCTION':
		$code = 'calcul_introduction(\'' .
		  $boucles[$id_boucle]->type_requete . "',\n" .
		  index_pile($id_boucle,  "texte", &$boucles) . ",\n" .
		  index_pile($id_boucle,  "chapo", &$boucles) . ",\n" .
		  index_pile($id_boucle,  "descriptif", &$boucles) . ")\n"; 
		break;

	//
	// Divers types de champs
	//

	case 'NOM_SITE_SPIP':
		$code = "lire_meta('nom_site')";
		break;

	case 'EMAIL_WEBMASTER':
		$code = "lire_meta('email_webmaster')";
		break;

	case 'CHARSET':
		$code = "lire_meta('charset')";
		break;

	case 'LANG':
		$code = "lire_meta('langue_site')";
		break;

	case 'LANG_LEFT':
		$code = "lang_dir(\$GLOBALS['spip_lang'],'left','right')";
		break;

	case 'LANG_RIGHT':
		$code = "lang_dir(\$GLOBALS['spip_lang'],'right','left')";
		break;

	case 'LANG_DIR':
		$code = "lang_dir(\$GLOBALS['spip_lang'],'ltr','rtl')";
		break;

	case 'PUCE':
		$code = "propre('- ')";
		break;

	case 'DATE':
	  // Uniquement hors-boucles, pour la date passee dans l'URL ou  contexte_inclus
	  // est-ce bien sr ?
	  $code = index_pile($id_boucle,  'date', &$boucles);
		break;

	case 'DATE_NOUVEAUTES':
		$code = "((lire_meta('quoi_de_neuf') == 'oui' AND lire_meta('majnouv')) ? normaliser_date(lire_meta('majnouv')) : \"'0000-00-00'\")";
		break;

	case 'URL_SITE_SPIP':
		$code = "lire_meta('adresse_site')";
		break;

	case 'URL_ARTICLE':
		$code = "generer_url_article(" . 
		  index_pile($id_boucle,  'id_article', &$boucles) . 
		  ")" ;
		  if ($boucles[$id_boucle]->hash)
		    $code = "url_var_recherche(" . $code . ")";
		break;

	case 'URL_RUBRIQUE':
		$code = "generer_url_rubrique(" . 
		  index_pile($id_boucle,  'id_rubrique', &$boucles) . 
		  ")" ;
		  if ($boucles[$id_boucle]->hash)
		    $code = "url_var_recherche(" . $code . ")";
		break;

	case 'URL_BREVE':
		$code = "generer_url_breve(" .
		  index_pile($id_boucle,  'id_breve', &$boucles) . 
		  ")";
		  if ($boucles[$id_boucle]->hash)
		    $code = "url_var_recherche(" . $code . ")";
		break;

	case 'URL_MOT':
		$code = "generer_url_mot(" .
		  index_pile($id_boucle,  'id_mot', &$boucles) .
		  ")";
		  if ($boucles[$id_boucle]->hash)
		    $code = "url_var_recherche(" . $code . ")";
		break;

	case 'URL_FORUM':
		$code = "generer_url_forum(" .
		  index_pile($id_boucle,  'id_forum', &$boucles) .")";
		break;

	case 'URL_DOCUMENT':
		$code = "generer_url_document(" .
		  index_pile($id_boucle,  'id_document', &$boucles) . ")";
		break;

	case 'NOTES':
		$milieu = '$lacible = $GLOBALS["les_notes"];
			$GLOBALS["les_notes"] = "";
			$GLOBALS["compt_note"] = 0;
			$GLOBALS["marqueur_notes"] ++;
			';
		$code = '$lacible';
		break;

	case 'RECHERCHE':
		$code = 'htmlspecialchars($GLOBALS["recherche"])';
		break;

	case 'COMPTEUR_BOUCLE':
		$code = '$compteur_boucle';
		break;

	case 'TOTAL_BOUCLE':
	  $n = 0;
	  $b = $id_boucle;
	  // si $id_boucle est vide, c'est la racine 
	  // il faudrait dire  l'auteur du squelette que ca n'a pas de sens
	  while ($b != $id_mere)
	    {
	      $n++;
	      $b = $boucles[$b]->id_parent;
	      // a ne devrait pas arriver si id_mere != '',
	      // mais je ne prends pas le risque
	      if (!$b) break;
	    }
	$code = '$PileNum[$SP' . (($n==0) ? "" : "+$n") . ']';
	$boucles[$id_boucle]->numrows = true;
#	spip_log("TOTAL_BOUCLE: $id_boucle dans $id_mere");
		break;

	case 'POPULARITE':
		$code = 'ceil(min(100, 100 * ' .
		  index_pile($id_boucle,  "popularite", &$boucles) .
		  '/ max(1 , 0 + lire_meta(\'popularite_max\'))))';
		break;

	case 'POPULARITE_ABSOLUE':
		$code = 'ceil(' .
		  index_pile($id_boucle,  "popularite", &$boucles) .
		  ')';
		break;

	case 'POPULARITE_SITE':
                $code = 'ceil(lire_meta(\'popularite_total\'))';
                break;

        case 'POPULARITE_MAX':
                $code = 'ceil(lire_meta(\'popularite_max\'))';
                break;

	case 'EXTRA':
		$code = 'trim(' .
		  index_pile($id_boucle,  "extra", &$boucles) .
		  ')';
                if ($fonctions) {
                        // Gerer la notation [(#EXTRA|isbn)]
                        include_ecrire("inc_extra.php3");
                        reset($fonctions);
                        list($key, $champ_extra) = each($fonctions);
                        $type_extra = $boucles[$id_boucle]->type_requete;
                        if (extra_champ_valide($type_extra, $champ_extra)) {
                                unset($fonctions[$key]);
                                $code = "extra($code, '".addslashes($champ_extra
)."')";
                        }
                        // Appliquer les filtres definis par le webmestre
                        $filtres = extra_filtres($type_extra, $champ_extra);
                        if ($filtres) {
                                reset($filtres);
                                while (list(, $f) = each($filtres)) $code = "$f(
$code)";
                        }
                }
		break;

	//
	// Inserer directement un document dans le squelette
	//
	case 'EMBED_DOCUMENT':
		$milieu = "
		include_ecrire('inc_documents.php3');";
		$code = "embed_document(" .
		  index_pile($id_boucle,  'id_document', &$boucles) . ", '" .
			($fonctions) ? join($fonctions, "|") : "" .
			"', false)";
		$fonctions = "";
		break;


	//
	// Champ testant la presence d'une petition
	//
	case 'PETITION':
		$code = '(spip_fetch_array(spip_query("
SELECT	id_article
FROM	spip_petitions
WHERE	id_article=' . 
		  index_pile($id_boucle,  'id_article', &$boucles)
		  . '")) ? " " : "")';
		break;


	// Debut et fin de surlignage auto des mots de la recherche
	// on insre une balise Span avec une classe sans spec:
	// c'est transparent s'il n'y a pas de recherche,
	// sinon elles seront remplaces par les fontions de inc_surligne
	// flag_pcre est juste une flag signalant que preg_match est dispo.

	case 'DEBUT_SURLIGNE':
	  $code = ($flag_pcre ? ('\'<span class="spip_surligneconditionnel">\'') : '');
	  break;
	case 'FIN_SURLIGNE':
	  $code = ($flag_pcre ? ('\'</span class="spip_surligneconditionnel">\'') : '');
	  break;

	//
	// Formulaires de login
	//
	case 'LOGIN_PRIVE':
		$code = '"<"."?php include(\'inc-login.php3\'); login(\'\', \'prive\'); ?".">"'; 
		break;

	case 'LOGIN_PUBLIC':
		if ($fonctions) {
			while (list(, $nom) = each($fonctions))
				$lacible = "new Link('".$nom."')";
			$fonctions = array();
		} else {
		  $lacible = '\$GLOBALS[\'clean_link\']';
		}
		$code = '"<"."?php include(\'inc-login.php3\'); login(' . $lacible . ', false); ?".">"';
		break;

	case 'URL_LOGOUT':
                if ($fonctions) {
                        $url = "&url=".$fonctions[0];
                        $fonctions = array();
                } else {
                        $url = '&url=\'.urlencode(\$clean_link->getUrl()).\'';
                }
                $code = '"<"."?php if (\$GLOBALS[\'auteur_session\'][\'login\'])
 { echo \'spip_cookie.php3?logout_public=\'.\$GLOBALS[\'auteur_session\'][\'login\'].\'' . $url . '\'; } ?".">"';
		break;

	default:
	  // champ inconnu. Il s'auto-dnote.
	    $code = "'#$nom_champ'";
	  break;
	} // switch

  list($c,$m) = applique_filtres($fonctions, $code, $id_boucle, $boucles, $id_mere);
  return array($c,$milieu . $m);
}
?>
